Bill
A bill is an invoice received for products and services purchased from vendors. Bill object allows you to perform the following operations:
- Retrieve a specific bill or a list of bills
- Create a bill
- Update a bill
- Delete a bill
- cURL
- NODE.JS
- PHP
- C#
- PYTHON
- JAVA
The Bill Object
asterisk denotes required| Name | Description | Format | Attributes |
|---|---|---|---|
| date | Date when a bill is created in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time | Filterable, Sortable |
| number | This represents a bill number | string | Filterable, Sortable MaxLength = 50 |
| vendorId | Identifier of a vendor | uuid | Filterable |
| accountingDate | Date that determines the accounting period to which the transaction belongs in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time | |
| accountsPayableId | Identifier of the Accounts Payable account associated with the bill | uuid | |
| accountSplits | Represents the account splits | AccountSplits Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. | |
| amount | Total amount of a bill | double | |
| balance | The outstanding amount on a bill | double | Filterable, Sortable |
| createdById | Identifier of the user who created this object | uuid | Filterable |
| createdOn | Date and time when this object was created (UTC Now), in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time | Filterable, Sortable |
| customFields []Array: Parent object can have multiple instances of this nested object under it. | List of custom fields | CustomFieldData Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. | |
| dueDate | The due date of a bill based on the payment terms set in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time | |
| expenseItems []Array: Parent object can have multiple instances of this nested object under it. | List of expense line items on a bill | BillExpenseItem Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. | |
| id | Object identifier | uuid | Filterable |
| lastUpdated | Last updated date and time value of this object in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time | Filterable, Sortable |
| lastUpdatedById | Identifier of the user who last updated this object | uuid | Filterable |
| lineItems []Array: Parent object can have multiple instances of this nested object under it. | List of line items on a bill | BillLineItem Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. | |
| memo | Records any extra information or details about a bill | string | |
| objectState | Represents the state of the object. e.g., new, unchanged, modified or deleted | ObjectState Enumerated type: Click to see possible values and their descriptions. | |
| paymentStatus | Payment status of a bill, whether paid, partially paid, or unpaid | BillPaymentStatus Enumerated type: Click to see possible values and their descriptions. | Filterable, Sortable |
| referenceNumber | Reference number used to track a bill | string | MaxLength = 200 |
| reimbursable | Indicates whether the bill is an employee reimbursable expense | boolean | Filterable, Sortable |
| term | Payment term associated with a bill, e.g., Due Upon Receipt, Net 30, etc. | string | |
| termId | Identifier of the payment term associated with a bill | uuid | |
| token | Represents the token for update operations | int32 | |
| vendor | Name of a vendor | string | |
| version | Implements concurrency on this object | byte | |
| workflow []Array: Parent object can have multiple instances of this nested object under it. | Determines a list of workflow | WorkflowState Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. |
Bill List
Use this method to retrieve a list of bills. You can optionally pass where, orderBy, and page as query parameters to filter the result. Use the fields parameter to request a subset of the model. By default, a complete model is returned. The expand parameter is used to request nested properties in the model.
Request URL
Method Overview
HTTP Method:
GET
Content Type:
application/json
Response Format:
json
Requires Authentication?
Yes
Headers:
Module:
Bill
Required Scopes:
read:core
Required Subscription:
View Subscription
Request Parameters asterisk denotes required
| Name | Parameter Type | Description | Format |
|---|---|---|---|
| fields | Query | Specifies the model properties you want in the response body | string |
| where | Query | Specifies only those records that match an expression in the query. | string |
| orderBy | Query | Specifies the order of the records. | string |
| page | Query | Specifies the page number and number of records on each page. | string |
| expand | Query | Specifies the nested model properties you want in the response body | string |
Response Body
| Name | Description | Format |
|---|---|---|
| date | Date when a bill is created in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time |
| number | This represents a bill number | string |
| vendorId | Identifier of a vendor | uuid |
| accountingDate | Date that determines the accounting period to which the transaction belongs in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time |
| accountsPayableId | Identifier of the Accounts Payable account associated with the bill | uuid |
| accountSplits | Represents the account splits | AccountSplits Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. |
| amount | Total amount of a bill | double |
| balance | The outstanding amount on a bill | double |
| createdById | Identifier of the user who created this object | uuid |
| createdOn | Date and time when this object was created (UTC Now), in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time |
| customFields []Array: Parent object can have multiple instances of this nested object under it. | List of custom fields | CustomFieldData Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. |
| dueDate | The due date of a bill based on the payment terms set in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time |
| expenseItems []Array: Parent object can have multiple instances of this nested object under it. | List of expense line items on a bill | BillExpenseItem Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. |
| id | Object identifier | uuid |
| lastUpdated | Last updated date and time value of this object in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time |
| lastUpdatedById | Identifier of the user who last updated this object | uuid |
| lineItems []Array: Parent object can have multiple instances of this nested object under it. | List of line items on a bill | BillLineItem Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. |
| memo | Records any extra information or details about a bill | string |
| objectState | Represents the state of the object. e.g., new, unchanged, modified or deleted | ObjectStateEnumerated type: Click to see possible values and their descriptions. |
| paymentStatus | Payment status of a bill, whether paid, partially paid, or unpaid | BillPaymentStatusEnumerated type: Click to see possible values and their descriptions. |
| referenceNumber | Reference number used to track a bill | string |
| reimbursable | Indicates whether the bill is an employee reimbursable expense | boolean |
| term | Payment term associated with a bill, e.g., Due Upon Receipt, Net 30, etc. | string |
| termId | Identifier of the payment term associated with a bill | uuid |
| token | Represents the token for update operations | int32 |
| vendor | Name of a vendor | string |
| version | Implements concurrency on this object | byte |
| workflow []Array: Parent object can have multiple instances of this nested object under it. | Determines a list of workflow | WorkflowState Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. |
[
{
"date": "2026-05-21T06:31:22Z",
"number": "173567",
"vendorId": "a9c32b55-36cd-475e-a5bc-da7f037edee4",
"accountingDate": "2026-05-21T06:31:22Z",
"accountsPayableId": "0c902f71-85bc-415f-8885-1fdc1ff50cf6",
"accountSplits": {
"accrual": [
{
"account": "account",
"accountId": "9fd25b90-af3d-4832-a487-bcf1f4588250",
"amount": 1,
"isDebit": true,
"isParent": true,
"transactionType": null
}
],
"cash": [
{
"account": "account",
"accountId": "fe0b2620-7cdf-4c6d-9750-20efd100a864",
"amount": 1,
"isDebit": true,
"isParent": true,
"transactionType": null
}
]
},
"amount": 1,
"balance": 1,
"createdById": "9d8728db-6c90-4b65-8169-c62e7412421c",
"createdOn": "2026-05-21T06:31:22Z",
"customFields": [
{
"definitionId": "d5bf2a8d-7c32-4a0e-98b7-c91188191e94",
"createdById": "53b6f14c-c433-435a-b396-f3234e99f3c6",
"createdOn": "2026-05-21T06:31:22Z",
"description": "CustomFieldData Description",
"id": "cde14e14-8392-47a6-a831-a3b7af480c64",
"label": "label",
"lastUpdated": "2026-05-21T06:31:22Z",
"lastUpdatedById": "c4f66d5c-4105-4c1c-a206-b73c9e922738",
"objectState": null,
"token": 0,
"type": null,
"value": "value",
"version": "U3dhZ2dlciByb2Nrcw=="
}
],
"dueDate": "2026-05-21T06:31:22Z",
"expenseItems": [
{
"accountId": "540b3306-ed29-4302-9304-06428da843df",
"amount": 1,
"account": "account",
"class": "class",
"classId": "4050eb15-83ec-46ac-8216-3df2472b68aa",
"createdById": "f5fea921-0046-41cd-9a40-6c93ff14606b",
"createdOn": "2026-05-21T06:31:22Z",
"entity": "entity",
"entityId": "dfa0e8bb-0318-43b3-869a-2afec68565ab",
"entityType": null,
"id": "23c78018-84ca-47a7-a659-29236295b605",
"lastUpdated": "2026-05-21T06:31:22Z",
"lastUpdatedById": "83fb7afc-9485-4693-97a9-a9cc2d388290",
"memo": "memo",
"objectState": null,
"token": 0,
"version": "U3dhZ2dlciByb2Nrcw=="
}
],
"id": "8dc40e37-b446-4e1c-9452-288bfb41b6d0",
"lastUpdated": "2026-05-21T06:31:22Z",
"lastUpdatedById": "5426b5ec-9018-45b5-b545-0d1ebdce39a9",
"lineItems": [
{
"itemId": "7b30eb48-6e40-4118-a40b-8e6d411af5a4",
"itemType": null,
"projectId": "bebfc393-2187-47b7-8802-0a57cde767c9",
"rate": 1,
"units": 1,
"amount": 1,
"billable": true,
"billRate": 1,
"class": "class",
"classId": "da17da8b-cb96-4c92-8271-63dfcf6c8cef",
"createdById": "5e44223a-9077-43b3-bdbc-60805c067bbd",
"createdOn": "2026-05-21T06:31:22Z",
"description": "BillLineItem Description",
"expenseAccount": "expenseAccount",
"expenseAccountId": "3771449e-1de9-4ec0-9b45-9a957ada8ca9",
"extra": true,
"id": "41d7421c-55f0-446a-b122-99bc5b6042af",
"incomeAccount": "incomeAccount",
"incomeAccountId": "d7d93a19-aa00-496e-968b-2abfb90ba154",
"item": "item",
"lastUpdated": "2026-05-21T06:31:22Z",
"lastUpdatedById": "2352f64c-62dd-4a3b-aba1-a85e1cbb3df5",
"markup": 1,
"memo": "memo",
"objectState": null,
"project": "project",
"purchaseTaxRate": 1,
"token": 0,
"version": "U3dhZ2dlciByb2Nrcw=="
}
],
"memo": "memo",
"objectState": null,
"paymentStatus": null,
"referenceNumber": "referenceNumber",
"reimbursable": true,
"term": "term",
"termId": "512372a8-d245-4452-813a-b3c806cda3f3",
"token": 0,
"vendor": "vendor",
"version": "U3dhZ2dlciByb2Nrcw==",
"workflow": [
{
"actionById": "c76a74b0-a835-415a-9b92-dfe387bcdba8",
"action": null,
"actionBy": "actionBy",
"createdById": "25c94927-84c3-4204-9ee3-f31e4151a80d",
"createdOn": "2026-05-21T06:31:22Z",
"date": "2026-05-21T06:31:22Z",
"id": "a28dc743-55a5-4360-babf-c17df8afab52",
"lastUpdated": "2026-05-21T06:31:22Z",
"lastUpdatedById": "2eee5c93-2fe0-4d77-9543-407a0dd8cc69",
"memo": "memo",
"objectState": null,
"sendTo": "sendTo",
"sendToId": "656a3e07-c647-4a85-ac1a-421325fcd544",
"submitTo": null,
"token": 0,
"type": null,
"version": "U3dhZ2dlciByb2Nrcw=="
}
]
}
]Retrieve a Bill
Use this method to retrieve a specific bill. Pass id as the parameter.
Request URL
Method Overview
HTTP Method:
GET
Content Type:
application/json
Response Format:
json
Requires Authentication?
Yes
Headers:
Module:
Bill
Required Scopes:
read:core
Required Subscription:
View Subscription
Request Parameters asterisk denotes required
| Name | Parameter Type | Description | Format |
|---|---|---|---|
| id | Path | Bill identifier | string |
Response Body
| Name | Description | Format |
|---|---|---|
| date | Date when a bill is created in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time |
| number | This represents a bill number | string |
| vendorId | Identifier of a vendor | uuid |
| accountingDate | Date that determines the accounting period to which the transaction belongs in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time |
| accountsPayableId | Identifier of the Accounts Payable account associated with the bill | uuid |
| accountSplits | Represents the account splits | AccountSplits Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. |
| amount | Total amount of a bill | double |
| balance | The outstanding amount on a bill | double |
| createdById | Identifier of the user who created this object | uuid |
| createdOn | Date and time when this object was created (UTC Now), in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time |
| customFields []Array: Parent object can have multiple instances of this nested object under it. | List of custom fields | CustomFieldData Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. |
| dueDate | The due date of a bill based on the payment terms set in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time |
| expenseItems []Array: Parent object can have multiple instances of this nested object under it. | List of expense line items on a bill | BillExpenseItem Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. |
| id | Object identifier | uuid |
| lastUpdated | Last updated date and time value of this object in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time |
| lastUpdatedById | Identifier of the user who last updated this object | uuid |
| lineItems []Array: Parent object can have multiple instances of this nested object under it. | List of line items on a bill | BillLineItem Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. |
| memo | Records any extra information or details about a bill | string |
| objectState | Represents the state of the object. e.g., new, unchanged, modified or deleted | ObjectStateEnumerated type: Click to see possible values and their descriptions. |
| paymentStatus | Payment status of a bill, whether paid, partially paid, or unpaid | BillPaymentStatusEnumerated type: Click to see possible values and their descriptions. |
| referenceNumber | Reference number used to track a bill | string |
| reimbursable | Indicates whether the bill is an employee reimbursable expense | boolean |
| term | Payment term associated with a bill, e.g., Due Upon Receipt, Net 30, etc. | string |
| termId | Identifier of the payment term associated with a bill | uuid |
| token | Represents the token for update operations | int32 |
| vendor | Name of a vendor | string |
| version | Implements concurrency on this object | byte |
| workflow []Array: Parent object can have multiple instances of this nested object under it. | Determines a list of workflow | WorkflowState Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. |
{
"date": "2026-05-21T06:31:22Z",
"number": "173567",
"vendorId": "9957b594-35e3-41ca-9139-02d187319c61",
"accountingDate": "2026-05-21T06:31:22Z",
"accountsPayableId": "66264ea1-c0b7-4654-89ff-2b0ac58aca4a",
"accountSplits": {
"accrual": [
{
"account": "account",
"accountId": "2e7f906f-6207-4ece-9c90-1ebacb4f410e",
"amount": 1,
"isDebit": true,
"isParent": true,
"transactionType": null
}
],
"cash": [
{
"account": "account",
"accountId": "44e1ce9f-6510-427a-842d-bd713f451b3a",
"amount": 1,
"isDebit": true,
"isParent": true,
"transactionType": null
}
]
},
"amount": 1,
"balance": 1,
"createdById": "0e58084f-b0f3-46b3-a9f8-6669c4c7e8bd",
"createdOn": "2026-05-21T06:31:22Z",
"customFields": [
{
"definitionId": "40203cd8-66df-4577-a708-1dff0e6c2011",
"createdById": "95c61621-a42c-4a87-bd6a-2c37aa4f20a2",
"createdOn": "2026-05-21T06:31:22Z",
"description": "CustomFieldData Description",
"id": "bd29d459-dd61-421b-8a3f-1b7b7efd5508",
"label": "label",
"lastUpdated": "2026-05-21T06:31:22Z",
"lastUpdatedById": "0603d315-68e1-45ee-97ad-bff14df9d3cb",
"objectState": null,
"token": 0,
"type": null,
"value": "value",
"version": "U3dhZ2dlciByb2Nrcw=="
}
],
"dueDate": "2026-05-21T06:31:22Z",
"expenseItems": [
{
"accountId": "962cf365-5b3c-4239-a827-3b55ed5f4faa",
"amount": 1,
"account": "account",
"class": "class",
"classId": "b39af820-9b05-4004-89f7-334e2578da44",
"createdById": "568eae52-8a7f-4a35-b835-c13b0e8605fc",
"createdOn": "2026-05-21T06:31:22Z",
"entity": "entity",
"entityId": "484b4c92-c58e-47b5-85e6-ec721e686946",
"entityType": null,
"id": "ff1190b4-3d6e-4e8f-b3e0-0de72b96574e",
"lastUpdated": "2026-05-21T06:31:22Z",
"lastUpdatedById": "3c590966-3feb-4989-8123-01393d95f9fe",
"memo": "memo",
"objectState": null,
"token": 0,
"version": "U3dhZ2dlciByb2Nrcw=="
}
],
"id": "a5c10bb9-4ea7-42ba-a0e6-01be3389f5c4",
"lastUpdated": "2026-05-21T06:31:22Z",
"lastUpdatedById": "cbbff4de-b680-4d6a-804a-ac6d77e2ed27",
"lineItems": [
{
"itemId": "f69a18f4-038a-44d5-8906-45adba1f38a2",
"itemType": null,
"projectId": "29aaa4a2-4bcc-4e5a-be64-cd81fbf6a3b2",
"rate": 1,
"units": 1,
"amount": 1,
"billable": true,
"billRate": 1,
"class": "class",
"classId": "1ae75648-bc46-4034-8413-96081e839d9e",
"createdById": "701239a2-892f-4328-8324-ff34c09c5d3e",
"createdOn": "2026-05-21T06:31:22Z",
"description": "BillLineItem Description",
"expenseAccount": "expenseAccount",
"expenseAccountId": "32ad652a-d881-4b67-a8e3-1e66b80a5f03",
"extra": true,
"id": "6465f1f5-5b55-4a90-9ed8-bb08a7c9e73a",
"incomeAccount": "incomeAccount",
"incomeAccountId": "0f378de8-2993-4cea-b74d-af5d228d3a2e",
"item": "item",
"lastUpdated": "2026-05-21T06:31:22Z",
"lastUpdatedById": "ba96cf67-2ba4-4cf8-a155-334263db44a5",
"markup": 1,
"memo": "memo",
"objectState": null,
"project": "project",
"purchaseTaxRate": 1,
"token": 0,
"version": "U3dhZ2dlciByb2Nrcw=="
}
],
"memo": "memo",
"objectState": null,
"paymentStatus": null,
"referenceNumber": "referenceNumber",
"reimbursable": true,
"term": "term",
"termId": "6966962b-fe1d-42f8-a620-298a9e4f4021",
"token": 0,
"vendor": "vendor",
"version": "U3dhZ2dlciByb2Nrcw==",
"workflow": [
{
"actionById": "7fe7745a-e73b-4865-be56-185d2f6047b8",
"action": null,
"actionBy": "actionBy",
"createdById": "dbefa912-3957-4779-bdf8-c5fdc5b60c81",
"createdOn": "2026-05-21T06:31:23Z",
"date": "2026-05-21T06:31:23Z",
"id": "8f5f6a82-3aef-4fe1-893d-90d54daa6f6b",
"lastUpdated": "2026-05-21T06:31:23Z",
"lastUpdatedById": "c3267aa6-c321-443a-9dff-4f483806f643",
"memo": "memo",
"objectState": null,
"sendTo": "sendTo",
"sendToId": "1fbf46d7-6173-4c59-af69-ccc0c2538f6d",
"submitTo": null,
"token": 0,
"type": null,
"version": "U3dhZ2dlciByb2Nrcw=="
}
]
}Method Overview
HTTP Method:
POST
Content Type:
application/json
Response Format:
json
Requires Authentication?
Yes
Headers:
Module:
Bill
Required Scopes:
readwrite:core
Required Subscription:
View Subscription
Request Parameters asterisk denotes required
| Name | Parameter Type | Description | Format |
|---|---|---|---|
| body | Body | Bill object | Bill |
Response Body
| Name | Description | Format |
|---|---|---|
| date | Date when a bill is created in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time |
| number | This represents a bill number | string |
| vendorId | Identifier of a vendor | uuid |
| accountingDate | Date that determines the accounting period to which the transaction belongs in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time |
| accountsPayableId | Identifier of the Accounts Payable account associated with the bill | uuid |
| accountSplits | Represents the account splits | AccountSplits Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. |
| amount | Total amount of a bill | double |
| balance | The outstanding amount on a bill | double |
| createdById | Identifier of the user who created this object | uuid |
| createdOn | Date and time when this object was created (UTC Now), in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time |
| customFields []Array: Parent object can have multiple instances of this nested object under it. | List of custom fields | CustomFieldData Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. |
| dueDate | The due date of a bill based on the payment terms set in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time |
| expenseItems []Array: Parent object can have multiple instances of this nested object under it. | List of expense line items on a bill | BillExpenseItem Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. |
| id | Object identifier | uuid |
| lastUpdated | Last updated date and time value of this object in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time |
| lastUpdatedById | Identifier of the user who last updated this object | uuid |
| lineItems []Array: Parent object can have multiple instances of this nested object under it. | List of line items on a bill | BillLineItem Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. |
| memo | Records any extra information or details about a bill | string |
| objectState | Represents the state of the object. e.g., new, unchanged, modified or deleted | ObjectStateEnumerated type: Click to see possible values and their descriptions. |
| paymentStatus | Payment status of a bill, whether paid, partially paid, or unpaid | BillPaymentStatusEnumerated type: Click to see possible values and their descriptions. |
| referenceNumber | Reference number used to track a bill | string |
| reimbursable | Indicates whether the bill is an employee reimbursable expense | boolean |
| term | Payment term associated with a bill, e.g., Due Upon Receipt, Net 30, etc. | string |
| termId | Identifier of the payment term associated with a bill | uuid |
| token | Represents the token for update operations | int32 |
| vendor | Name of a vendor | string |
| version | Implements concurrency on this object | byte |
| workflow []Array: Parent object can have multiple instances of this nested object under it. | Determines a list of workflow | WorkflowState Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. |
{
"date": "2026-05-21T06:31:22Z",
"number": "173567",
"vendorId": "e94faaf4-dbb5-4c9a-9b3f-2fe5350ce580",
"accountingDate": "2026-05-21T06:31:22Z",
"accountsPayableId": "c553711e-ceb4-4ca9-b108-1b1c01851353",
"accountSplits": {
"accrual": [
{
"account": "account",
"accountId": "9e336444-8a4b-4098-8fa2-0da4a48abecf",
"amount": 1,
"isDebit": true,
"isParent": true,
"transactionType": null
}
],
"cash": [
{
"account": "account",
"accountId": "904d24aa-5b4d-4674-a5de-7e9da9471ed5",
"amount": 1,
"isDebit": true,
"isParent": true,
"transactionType": null
}
]
},
"amount": 1,
"balance": 1,
"createdById": "ef46ac94-2612-4626-b4a7-589d0a4bcf03",
"createdOn": "2026-05-21T06:31:22Z",
"customFields": [
{
"definitionId": "8504adbf-fe5f-4680-98dc-f2a3a141f62c",
"createdById": "6b19bcab-b74c-4388-980c-87bc096a9567",
"createdOn": "2026-05-21T06:31:22Z",
"description": "CustomFieldData Description",
"id": "65801d7f-2f8d-4eca-8175-89ce8d7676f8",
"label": "label",
"lastUpdated": "2026-05-21T06:31:22Z",
"lastUpdatedById": "8fe62436-b5e5-4db9-b90e-8e0ed49ff863",
"objectState": null,
"token": 0,
"type": null,
"value": "value",
"version": "U3dhZ2dlciByb2Nrcw=="
}
],
"dueDate": "2026-05-21T06:31:22Z",
"expenseItems": [
{
"accountId": "387c036a-215d-4a33-8aad-7634e654b65b",
"amount": 1,
"account": "account",
"class": "class",
"classId": "25035cad-a69a-4c3f-9218-7e060d7f7c7a",
"createdById": "ed9b35cc-7f4d-4bc7-86b1-c668b0b0b79f",
"createdOn": "2026-05-21T06:31:22Z",
"entity": "entity",
"entityId": "79ff60af-520c-4181-8c9d-1144da7aba8c",
"entityType": null,
"id": "e51cd241-8bde-4f00-aed4-0ff50dc6ca90",
"lastUpdated": "2026-05-21T06:31:22Z",
"lastUpdatedById": "494bd079-a14b-4709-a80a-676e0f10aa03",
"memo": "memo",
"objectState": null,
"token": 0,
"version": "U3dhZ2dlciByb2Nrcw=="
}
],
"id": "2974b743-36b9-4404-a764-8493b15dbdf9",
"lastUpdated": "2026-05-21T06:31:22Z",
"lastUpdatedById": "2a78a856-09ec-4f7b-be1b-db85941fcb9e",
"lineItems": [
{
"itemId": "f8824bde-0368-4de3-8f5c-3b91e19c3380",
"itemType": null,
"projectId": "91f51911-a565-4e1a-b8bc-938135f3bfbf",
"rate": 1,
"units": 1,
"amount": 1,
"billable": true,
"billRate": 1,
"class": "class",
"classId": "9b9581f1-221d-401c-89da-471247cb9d76",
"createdById": "f4b2e609-631c-4c4e-9fa1-430c98a9be67",
"createdOn": "2026-05-21T06:31:22Z",
"description": "BillLineItem Description",
"expenseAccount": "expenseAccount",
"expenseAccountId": "7ca5cd83-9c3d-4de0-b1c8-88906e6b4612",
"extra": true,
"id": "ff28f99c-dc67-40df-bc39-8dbf6a3b8508",
"incomeAccount": "incomeAccount",
"incomeAccountId": "c87c0a3e-8537-4955-b45d-b478113687df",
"item": "item",
"lastUpdated": "2026-05-21T06:31:22Z",
"lastUpdatedById": "5e0d3534-8f3f-49e5-a5ea-227eb9ea065e",
"markup": 1,
"memo": "memo",
"objectState": null,
"project": "project",
"purchaseTaxRate": 1,
"token": 0,
"version": "U3dhZ2dlciByb2Nrcw=="
}
],
"memo": "memo",
"objectState": null,
"paymentStatus": null,
"referenceNumber": "referenceNumber",
"reimbursable": true,
"term": "term",
"termId": "4d9805d6-6aee-4506-ab56-c195b8191071",
"token": 0,
"vendor": "vendor",
"version": "U3dhZ2dlciByb2Nrcw==",
"workflow": [
{
"actionById": "1ac7aa49-29de-4f80-aca7-f31370b90fd1",
"action": null,
"actionBy": "actionBy",
"createdById": "9f304782-08f2-43a5-9a5b-32609a62328b",
"createdOn": "2026-05-21T06:31:22Z",
"date": "2026-05-21T06:31:22Z",
"id": "23b57585-da3f-462d-9002-f3a97ea4647a",
"lastUpdated": "2026-05-21T06:31:22Z",
"lastUpdatedById": "d3c744cc-5627-4ea5-9b69-47a3f17df58b",
"memo": "memo",
"objectState": null,
"sendTo": "sendTo",
"sendToId": "e35b94da-4f2f-43bd-b431-2b472002fbe5",
"submitTo": null,
"token": 0,
"type": null,
"version": "U3dhZ2dlciByb2Nrcw=="
}
]
}Create a Bill List
Use this method to save multiple bill. Pass model as the parameter.
As saving multiple records in a batch takes time, this endpoint returns a Job object that shows the progress of the batch operation. To check the status of the operation at any time, use the job endpoint.
Request URL
Method Overview
HTTP Method:
POST
Content Type:
application/json
Response Format:
json
Requires Authentication?
Yes
Headers:
Module:
Bill
Required Scopes:
readwrite:core
Required Subscription:
View Subscription
Request Parameters asterisk denotes required
| Name | Parameter Type | Description | Format |
|---|---|---|---|
| body | Body | Bill object | BillBatchRequest |
Response Body
| Name | Description | Format |
|---|---|---|
| batchSize | Represents the number of entities in a batch | int64 |
| createdById | Identifier of the user who created this object | uuid |
| createdOn | Date and time when this object was created (UTC Now), in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time |
| id | Object identifier | uuid |
| lastUpdated | Last updated date and time value of this object in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time |
| lastUpdatedById | Identifier of the user who last updated this object | uuid |
| objectState | Represents the state of the object. e.g., new, unchanged, modified or deleted | ObjectStateEnumerated type: Click to see possible values and their descriptions. |
| progress | Represents the total number of entities processed | int64 |
| status | Represents the status of a job e.g., ready, running, completed, or terminated | string |
| token | Represents the token for update operations | int32 |
| type | Represents the type of a job e.g., create, update, or delete | string |
| version | Implements concurrency on this object | byte |
{
"batchSize": 0,
"createdById": "c205ac32-ac43-4961-b407-5fed35afe000",
"createdOn": "2026-05-21T06:31:23Z",
"id": "f3c2897d-1cf8-49e3-bc24-61f4fcafa9a5",
"lastUpdated": "2026-05-21T06:31:23Z",
"lastUpdatedById": "91d7d643-beda-4db7-ba04-2c8360e492d5",
"objectState": null,
"progress": 0,
"status": "status",
"token": 0,
"type": "type",
"version": "U3dhZ2dlciByb2Nrcw=="
}Update a Bill
Use this method to update a bill. Pass id and bill as the parameters.
Request URL
Method Overview
HTTP Method:
PUT
Content Type:
application/json
Response Format:
json
Requires Authentication?
Yes
Headers:
Module:
Bill
Required Scopes:
readwrite:core
Required Subscription:
View Subscription
Request Parameters asterisk denotes required
| Name | Parameter Type | Description | Format |
|---|---|---|---|
| id | Path | Bill identifier | string |
| body | Body | Bill object | Bill |
Response Body
| Name | Description | Format |
|---|---|---|
| date | Date when a bill is created in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time |
| number | This represents a bill number | string |
| vendorId | Identifier of a vendor | uuid |
| accountingDate | Date that determines the accounting period to which the transaction belongs in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time |
| accountsPayableId | Identifier of the Accounts Payable account associated with the bill | uuid |
| accountSplits | Represents the account splits | AccountSplits Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. |
| amount | Total amount of a bill | double |
| balance | The outstanding amount on a bill | double |
| createdById | Identifier of the user who created this object | uuid |
| createdOn | Date and time when this object was created (UTC Now), in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time |
| customFields []Array: Parent object can have multiple instances of this nested object under it. | List of custom fields | CustomFieldData Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. |
| dueDate | The due date of a bill based on the payment terms set in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time |
| expenseItems []Array: Parent object can have multiple instances of this nested object under it. | List of expense line items on a bill | BillExpenseItem Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. |
| id | Object identifier | uuid |
| lastUpdated | Last updated date and time value of this object in ISO 8601 date-time format, such as YYYY-MM-DDThh:mm:ss | date-time |
| lastUpdatedById | Identifier of the user who last updated this object | uuid |
| lineItems []Array: Parent object can have multiple instances of this nested object under it. | List of line items on a bill | BillLineItem Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. |
| memo | Records any extra information or details about a bill | string |
| objectState | Represents the state of the object. e.g., new, unchanged, modified or deleted | ObjectStateEnumerated type: Click to see possible values and their descriptions. |
| paymentStatus | Payment status of a bill, whether paid, partially paid, or unpaid | BillPaymentStatusEnumerated type: Click to see possible values and their descriptions. |
| referenceNumber | Reference number used to track a bill | string |
| reimbursable | Indicates whether the bill is an employee reimbursable expense | boolean |
| term | Payment term associated with a bill, e.g., Due Upon Receipt, Net 30, etc. | string |
| termId | Identifier of the payment term associated with a bill | uuid |
| token | Represents the token for update operations | int32 |
| vendor | Name of a vendor | string |
| version | Implements concurrency on this object | byte |
| workflow []Array: Parent object can have multiple instances of this nested object under it. | Determines a list of workflow | WorkflowState Nested object: Click to see its details. To retrieve the details of this object via list endpoints, you must use the Expand parameter. |
{
"date": "2026-05-21T06:31:23Z",
"number": "173567",
"vendorId": "9cbdc123-48d1-44e2-8ea0-b13d9284077a",
"accountingDate": "2026-05-21T06:31:23Z",
"accountsPayableId": "317c60f6-4742-4bb4-a4f0-bbfc14a45973",
"accountSplits": {
"accrual": [
{
"account": "account",
"accountId": "ef2e9e94-b648-453f-a547-622a55bfe3c8",
"amount": 1,
"isDebit": true,
"isParent": true,
"transactionType": null
}
],
"cash": [
{
"account": "account",
"accountId": "a0194597-7bed-4b23-bd6a-a1233f704f46",
"amount": 1,
"isDebit": true,
"isParent": true,
"transactionType": null
}
]
},
"amount": 1,
"balance": 1,
"createdById": "9cdfc3ce-b20e-4c48-a255-cb56a1ff6767",
"createdOn": "2026-05-21T06:31:23Z",
"customFields": [
{
"definitionId": "ca1192b7-5219-49db-8713-4adec1272ba1",
"createdById": "e0459372-5c65-4521-87c6-6710c5cf1d24",
"createdOn": "2026-05-21T06:31:23Z",
"description": "CustomFieldData Description",
"id": "9950b02e-ba85-417d-a756-5d41c37bf867",
"label": "label",
"lastUpdated": "2026-05-21T06:31:23Z",
"lastUpdatedById": "f243e6aa-62d0-4542-a030-7321c0d4290e",
"objectState": null,
"token": 0,
"type": null,
"value": "value",
"version": "U3dhZ2dlciByb2Nrcw=="
}
],
"dueDate": "2026-05-21T06:31:23Z",
"expenseItems": [
{
"accountId": "b9768deb-b48f-4afc-b5e3-2c1529fb08b0",
"amount": 1,
"account": "account",
"class": "class",
"classId": "d7c2a3a7-86e3-4452-ab3e-fe0be56902fc",
"createdById": "79d14afe-a3a3-45d4-8ded-6865f2b06099",
"createdOn": "2026-05-21T06:31:23Z",
"entity": "entity",
"entityId": "33941981-8380-488b-99e4-1bd9c3c0396d",
"entityType": null,
"id": "f8bd3506-327a-49a1-b00a-5c1e4314f384",
"lastUpdated": "2026-05-21T06:31:23Z",
"lastUpdatedById": "f54a8cdf-1d8e-46d2-ac04-de2885df26fd",
"memo": "memo",
"objectState": null,
"token": 0,
"version": "U3dhZ2dlciByb2Nrcw=="
}
],
"id": "06d31a0f-b5dc-499a-b681-f4872e8d6ffc",
"lastUpdated": "2026-05-21T06:31:23Z",
"lastUpdatedById": "e2bec786-ddae-443d-a1cf-1574949c137c",
"lineItems": [
{
"itemId": "c74333c4-b352-4eb7-9d62-3fa02f272818",
"itemType": null,
"projectId": "e3118492-db8a-4935-a14e-b5e8afa3d1c6",
"rate": 1,
"units": 1,
"amount": 1,
"billable": true,
"billRate": 1,
"class": "class",
"classId": "bbb3e0b1-9378-4bb9-998a-d5f24c991692",
"createdById": "89df398c-2750-43d4-bd39-e147d0b88fa9",
"createdOn": "2026-05-21T06:31:23Z",
"description": "BillLineItem Description",
"expenseAccount": "expenseAccount",
"expenseAccountId": "b0f825ba-5223-4c68-9bc1-c885cd64864d",
"extra": true,
"id": "8e386735-e7b4-4252-bf00-6d7a16783cb7",
"incomeAccount": "incomeAccount",
"incomeAccountId": "41035216-e2dc-45ea-8ea1-b211c0ccd751",
"item": "item",
"lastUpdated": "2026-05-21T06:31:23Z",
"lastUpdatedById": "88cd940b-5f6a-4088-a299-e139a95d7d69",
"markup": 1,
"memo": "memo",
"objectState": null,
"project": "project",
"purchaseTaxRate": 1,
"token": 0,
"version": "U3dhZ2dlciByb2Nrcw=="
}
],
"memo": "memo",
"objectState": null,
"paymentStatus": null,
"referenceNumber": "referenceNumber",
"reimbursable": true,
"term": "term",
"termId": "d189e369-ccd1-4a3c-b412-ee5206491e6c",
"token": 0,
"vendor": "vendor",
"version": "U3dhZ2dlciByb2Nrcw==",
"workflow": [
{
"actionById": "1b0a0049-0aee-43f9-bb21-ddec9ba15274",
"action": null,
"actionBy": "actionBy",
"createdById": "816a25dd-ca02-43d4-bc3c-6ef9e1dc2e09",
"createdOn": "2026-05-21T06:31:23Z",
"date": "2026-05-21T06:31:23Z",
"id": "cd8d50c7-f1d9-40c5-b487-3993eb88ff7a",
"lastUpdated": "2026-05-21T06:31:23Z",
"lastUpdatedById": "0da80788-2436-400a-8f37-d295f805dfc3",
"memo": "memo",
"objectState": null,
"sendTo": "sendTo",
"sendToId": "6efdd8fa-b391-40d9-a2bc-c5a46e99b264",
"submitTo": null,
"token": 0,
"type": null,
"version": "U3dhZ2dlciByb2Nrcw=="
}
]
}Delete a Bill
Use this method to delete a bill. Pass id as the parameter.
Request URL
Method Overview
HTTP Method:
DELETE
Content Type:
application/json
Response Format:
N/A
Requires Authentication?
Yes
Headers:
Required Scopes:
readwrite:core
Required Subscription:
View Subscription
Request Parameters asterisk denotes required
| Name | Parameter Type | Description | Format |
|---|---|---|---|
| id | Path | Bill identifier | string |
Patch a Bill
Use this method to perform partial modifications to a bill. Pass id and patch document as parameters.
Request URL
Method Overview
HTTP Method:
PATCH
Content Type:
application/json
Response Format:
json
Requires Authentication?
Yes
Headers:
Module:
Bill
Required Scopes:
readwrite:core
Required Subscription:
View Subscription
Request Parameters asterisk denotes required
| Name | Parameter Type | Description | Format |
|---|---|---|---|
| id | Path | Bill identifier | string |
| body | Body | A document containing an array of objects with each object representing a single operation to be performed | BillPatchDocument |
Response Body
| Name | Description | Format |
|---|